import { TypeInfo } from './type-info';
/**
 * Generator to emit classes and types for the L1 construct of the given resource type
 */
export declare class CfnResourceGenerator {
    private readonly typeName;
    private readonly typeDef;
    private readonly schema;
    private readonly sanitizedTypeName;
    private readonly resourceAttributes;
    private readonly resourceProperties;
    private readonly constructClassName;
    private readonly propsStructName;
    /**
     *
     * @param typeName the name of the CFN resource type (e.g. AWSQS::EKS::Cluster)
     * @param typeDef the type info containing the source url
     * @param schema the schema of the resource type for input and output properties
     */
    constructor(typeName: string, typeDef: TypeInfo | undefined, schema: any);
    /**
     * Render the type into a TypeScript class fil defining the props and the L1 construct
     *
     * @returns the rendered class file content
     */
    render(): string;
    private emitImports;
    private emitDefinitionTypes;
    private emitConstructClass;
    private renderGetAtt;
    private getTypeOfProperty;
    private getTypeFromSchema;
    private isSupportedPrimitiveType;
}
